#define SECURITYFILERECTANGLE 2
#define SECURITYFILETIMESTAMP 1


#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/utsname.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <sys/types.h>

time_t then,lasttime;
FILE *fp;
int minx,maxx,miny,maxy,x,y,xsize = 640,ysize = 480,i,j,frameNumber;
int recsize;
int StartFrame = 0;
int StopFrame = 0;
int FrameCount = 0;
int CopiedFrameCount = 0;
int ThisGroupCount = 0;
int FirstFrameThisGroup = 0;
char bigbuf[400000];
long curfpos;
long win;
int c;

void usage(void);
void GetMyDate(time_t then,char *mydate);
void CopyRestOfFile(void);
void getdata();

char s[100];
char infilename[100];
char mydate[100];
int token,token2;

void getdata() {

    fp = fopen(infilename,"r");
    if(fp == NULL)
     {
      fprintf(stderr,"Could not open file '%s'\n",infilename);
      exit(1);
     }
 
     while(1)
      {

        fread(&token,sizeof(int),1,fp);
        if(feof(fp))
         {
           break;
         }

        switch(token){
       
        case SECURITYFILETIMESTAMP:
          FrameCount++;
          if(FrameCount == StartFrame)
            {
             CopyRestOfFile();
             exit(1);
            }
          fread(&then ,sizeof(time_t),1,fp);
          fread(&token,sizeof(int),1,fp);
          if(token != SECURITYFILERECTANGLE)
            {
             fprintf(stderr,"Did not find SECURITYFILERECTANGLE token\n");
             exit(1);
            }
         /*  ReadAndDrawFrame(); */
          fread(&minx,sizeof(int),1,fp);
          fread(&miny,sizeof(int),1,fp);
          fread(&maxx,sizeof(int),1,fp);
          fread(&maxy,sizeof(int),1,fp);
          recsize =   (maxx-minx+1) * (maxy-miny+1);
          fseek(fp,recsize,SEEK_CUR);
          if((then - lasttime) > 30)
            {
              if(FirstFrameThisGroup == 0)
               {
                FirstFrameThisGroup = 1;
                ThisGroupCount = 1;
               }
              else
               {
                GetMyDate(lasttime,mydate);
                printf("%5d,  %16s, %5d\n",FirstFrameThisGroup,mydate,ThisGroupCount);
                FirstFrameThisGroup = FrameCount;
                ThisGroupCount = 1;
               }
            }
          else
            {
              ThisGroupCount++;
            }
          lasttime = then;
          break;
        default:
           fprintf(stderr,"Unknown token %d found\n",token);
           while( !feof(fp))
            {
             token = 0;
             while((!feof(fp)) && (token != SECURITYFILETIMESTAMP))
               fread(&token,sizeof(int),1,fp);
             
             fread(&then,sizeof(time_t),1,fp);
             fread(&token,sizeof(int),1,fp);
             if(token != SECURITYFILERECTANGLE)
               continue;
             fread(&minx,sizeof(int),1,fp);
             fread(&miny,sizeof(int),1,fp);
             fread(&maxx,sizeof(int),1,fp);
             fread(&maxy,sizeof(int),1,fp);
             if((minx < 0) || (minx > 640)) continue;
             if((miny < 0) || (miny > 640)) continue;
             if((maxx < 0) || (maxx > 640)) continue;
             if((maxy < 0) || (maxy > 640)) continue;
               break;
            }
           if(feof(fp))
            {
              fprintf(stderr,"Unable to synchronize\n");
              exit(1);
            }
           else
            {
             curfpos = ftell(fp);
             curfpos -= sizeof(int);
             curfpos -= sizeof(time_t);
             curfpos -= sizeof(int);
             curfpos -= sizeof(int);
             curfpos -= sizeof(int);
             curfpos -= sizeof(int);
             curfpos -= sizeof(int);
             fseek(fp,curfpos,SEEK_SET);
             fprintf(stderr,"Resynched\n");
            }
           break;
        }  
     } 
}



int main(int argc, char **argv) 
 {
    long dev;
    short val;

    if(argc < 2)
     {
      usage();
      exit(1);
     }

    strcpy(infilename,argv[1]);

    if(argc > 2)
      StartFrame = atoi(argv[2]);

    if(argc == 4)
      StopFrame = atoi(argv[3]);
 
    printf("%5s   %16s  %s\n\n","Frame","Date    Time ","Number in group");
    getdata();

}               /* End of main (infinite) loop */


void usage(void)
{
fprintf(stderr,"USAGE: getframes filename StartFrame [StopFrame]\n\n");
fprintf(stderr,"typical use would be to only look at a small part of a securitylite\n");
fprintf(stderr,"data file.  Run once with filename only (no start or stop params). By \n");
fprintf(stderr,"checking the date information with the Frame Count value on the\n");
fprintf(stderr,"left you can determine which frame numbers you care about and then\n");
fprintf(stderr,"re-run the program to generate a new data file called 'small'.\n");
}




void CopyRestOfFile(void)
{
int buf;
long start;
FILE *nfp;

nfp = fopen("small","w");
if(nfp == NULL)
  {
   fprintf(stderr,"Could not open file 'small'\n");
   return;
  }
start = ftell(fp);
fseek(fp,start - sizeof(int),SEEK_SET);

while(!feof(fp))
 {
   fread(&token,sizeof(int),1,fp);   /* Read Token */
   if(feof(fp))
     break;
   CopiedFrameCount++;
   FrameCount++;
   fread (&then,sizeof(time_t),1,fp);  /* Read Time */
   if(FrameCount == StopFrame)
     {
      fclose(fp);
      fclose(nfp);
      printf("\n%d frames copied to file 'small'\n",CopiedFrameCount);
      exit(1);
     }

   fread(&token2,sizeof(int),1,fp);   /* Read Token 2 */
   fread(&minx,sizeof(int),1,fp);
   fread(&miny,sizeof(int),1,fp);
   fread(&maxx,sizeof(int),1,fp);
   fread(&maxy,sizeof(int),1,fp);
   recsize =  ( (maxx-minx+1) * (maxy-miny+1));


   fwrite(&token,sizeof(int),1,nfp);
   fwrite(&then,sizeof(time_t),1,nfp);
   fwrite(&token2,sizeof(int),1,nfp);   /* Write Token 2 */
   fwrite(&minx,sizeof(int),1,nfp);
   fwrite(&miny,sizeof(int),1,nfp);
   fwrite(&maxx,sizeof(int),1,nfp);
   fwrite(&maxy,sizeof(int),1,nfp);

/*
   for(i=0;i<recsize;i++)
     {
      fread (&buf,sizeof(char),1, fp);
      fwrite(&buf,sizeof(char),1,nfp);
      if(feof(fp)) break;
     }
*/
     fread(&bigbuf,recsize,1,fp);
     fwrite(&bigbuf,recsize,1,nfp);
 }
fclose(nfp);
fclose(fp);
fprintf(stderr,"Copy complete\n");
exit(1);
}



void GetMyDate(time_t then,char *mydate)
{
char *cp;
cp = ctime(&then);
mydate[0] = '\0';
cp += 4;
strncat(mydate,cp,3);
cp += 4;
strcat(mydate," ");
strncat(mydate,cp,2);
strcat(mydate," ");
cp += 3;
strncat(mydate,cp,2);
strcat(mydate,":");
cp += 3;
strncat(mydate,cp,2);
strcat(mydate,":");
cp += 3;
strncat(mydate,cp,2);
}


