#define SECURITYFILERECTANGLE 2
#define SECURITYFILETIMESTAMP 1


#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/utsname.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <sys/types.h>

time_t now,then,LastTime;
FILE *fp;
int minx,maxx,miny,maxy,x,y,xsize = 640,ysize = 480,i,j,frameNumber;
int pausemode = 0, paused = 0;
int recsize;
int StartMinute;
int StopMinute;
int FramesThisGroup;
time_t StartTimeThisGroup;
char bigbuf[400000];
long curfpos;
long win;
int c;

void usage(void);
void GetTimeStamp(void);
void GetMyDate(time_t then,char *mydate);
void CopyRestOfFile(void);
void getdata();

char s[100];
char infilename[100];
char mydate[100];
int FirstTimeThrough = 1;
int token,token2;

void getdata() {

    fp = fopen(infilename,"r");
    if(fp == NULL)
     {
      fprintf(stderr,"Could not open file '%s'\n",infilename);
      exit(1);
     }
 
     while(1)
      {
        fread(&token,sizeof(int),1,fp);
        if(feof(fp))
         {
           break;
         }

        switch(token){

        case SECURITYFILETIMESTAMP:
          GetTimeStamp();
          if((now-then)/60 <= StartMinute)
            {
             CopyRestOfFile();
             exit(1);
            }
          fread(&token,sizeof(int),1,fp);
          if(token != SECURITYFILERECTANGLE)
            {
             fprintf(stderr,"Did not find SECURITYFILERECTANGLE token\n");
             exit(1);
            }
         /*  ReadAndDrawFrame(); */
          fread(&minx,sizeof(int),1,fp);
          fread(&miny,sizeof(int),1,fp);
          fread(&maxx,sizeof(int),1,fp);
          fread(&maxy,sizeof(int),1,fp);
          recsize =   (maxx-minx+1) * (maxy-miny+1);
          fseek(fp,recsize,SEEK_CUR);
          if((then - LastTime) > 30)
            {
             GetMyDate(StartTimeThisGroup,mydate);
             printf("%5d,  %s,  %d\n",(now-then)/60,mydate,FramesThisGroup);
             FramesThisGroup = 1;
            }
          else
            {
             FramesThisGroup++;
             StartTimeThisGroup = then;
            }
          LastTime = then;
          break;
        default:
           fprintf(stderr,"Unknown token %d found\n",token);
           while( !feof(fp))
            {
             token = 0;
             while((!feof(fp)) && (token != SECURITYFILETIMESTAMP))
               fread(&token,sizeof(int),1,fp);
             
             fread(&then,sizeof(time_t),1,fp);
             fread(&token,sizeof(int),1,fp);
             if(token != SECURITYFILERECTANGLE)
               continue;
             fread(&minx,sizeof(int),1,fp);
             fread(&miny,sizeof(int),1,fp);
             fread(&maxx,sizeof(int),1,fp);
             fread(&maxy,sizeof(int),1,fp);
             if((minx < 0) || (minx > 640)) continue;
             if((miny < 0) || (miny > 640)) continue;
             if((maxx < 0) || (maxx > 640)) continue;
             if((maxy < 0) || (maxy > 640)) continue;
               break;
            }
           if(feof(fp))
            {
              fprintf(stderr,"Unable to synchronize\n");
              exit(1);
            }
           else
            {
             curfpos = ftell(fp);
             curfpos -= sizeof(int);
             curfpos -= sizeof(time_t);
             curfpos -= sizeof(int);
             curfpos -= sizeof(int);
             curfpos -= sizeof(int);
             curfpos -= sizeof(int);
             curfpos -= sizeof(int);
             fseek(fp,curfpos,SEEK_SET);
             fprintf(stderr,"Resynched\n");
            }
           break;
        }  
     } 
}



int main(int argc, char **argv) 
 {
    long dev;
    short val;

    StopMinute = 0;
    StartMinute = 0;
    now = time(0);   /* what is the actual time that this program is being run */

    printf("\n\n%5s   %s   %s\n","Minutes","date   time","Frames in this group");
    printf("%s\n\n","  Ago  ");

    if(argc < 2)
     {
      usage();
      exit(1);
     }

    strcpy(infilename,argv[1]);

    if(argc > 2)
      StartMinute = atoi(argv[2]);

    if(argc == 4)
      StopMinute = atoi(argv[3]);
 
    getdata();

}               /* End of main (infinite) loop */


void usage(void)
{
fprintf(stderr,"USAGE: getminutes filename StartMinute StopMinute\n\n");
fprintf(stderr,"typical use would be to only look at a small part of a securitylite\n");
fprintf(stderr,"data file.  Run once with minutecount set to 0 to see range.  By \n");
fprintf(stderr,"checking the date information with the elapsed minutes value on the\n");
fprintf(stderr,"left you can determine which minute range you care about and then\n");
fprintf(stderr,"re-run the program to generate a new data file called 'small'.\n");

}




void GetTimeStamp(void)
{
  fread(&then,sizeof(time_t),1,fp);
}



int CopiedFrameCount = 0;
void CopyRestOfFile(void)
{
int buf;
long start;
FILE *nfp;

nfp = fopen("small","w");
if(nfp == NULL)
  {
   fprintf(stderr,"Could not open file 'small'\n");
   return;
  }
start = ftell(fp);
fseek(fp,start-sizeof(time_t)-sizeof(int),SEEK_SET);
while(!feof(fp))
 {
   fread(&token,sizeof(int),1,fp);   /* Read Token */

   fread (&then,sizeof(time_t),1,fp);  /* Read Time */

   CopiedFrameCount++;
   if((now - then)/60 < StopMinute)
     {
      fclose(fp);
      fclose(nfp);
      printf("\nCopied %d frames to file 'small'\n\n",CopiedFrameCount);
      exit(1);
     }

   fread(&token2,sizeof(int),1,fp);   /* Read Token 2 */
   fread(&minx,sizeof(int),1,fp);
   fread(&miny,sizeof(int),1,fp);
   fread(&maxx,sizeof(int),1,fp);
   fread(&maxy,sizeof(int),1,fp);
   recsize =  ( (maxx-minx+1) * (maxy-miny+1));


   fwrite(&token,sizeof(int),1,nfp);
   fwrite(&then,sizeof(time_t),1,nfp);
   fwrite(&token2,sizeof(int),1,nfp);   /* Write Token 2 */
   fwrite(&minx,sizeof(int),1,nfp);
   fwrite(&miny,sizeof(int),1,nfp);
   fwrite(&maxx,sizeof(int),1,nfp);
   fwrite(&maxy,sizeof(int),1,nfp);

   fread(&bigbuf,recsize,1,fp);
   fwrite(&bigbuf,recsize,1,nfp);
 }
fclose(nfp);
fclose(fp);
printf("\nCopied %d frames to file 'small'\n\n",CopiedFrameCount);
exit(1);
}


void GetMyDate(time_t then,char *mydate)
{
char *cp;
cp = ctime(&then);
mydate[0] = '\0';
cp += 4;
strncat(mydate,cp,3);
cp += 4;
strcat(mydate," ");
strncat(mydate,cp,2);
strcat(mydate," ");
cp += 3;
strncat(mydate,cp,2);
strcat(mydate,":");
cp += 3;
strncat(mydate,cp,2);
strcat(mydate,":");
cp += 3;
strncat(mydate,cp,2);
}


