#define SECURITYFILERECTANGLE 2
#define SECURITYFILETIMESTAMP 1


#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <gl/gl.h>
#include <sys/utsname.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <sys/types.h>
#include <gl/gl.h>
#include <gl/device.h>
#include "image.h"

time_t now;
FILE *fp;
int minx,maxx,miny,maxy,x,y,xsize = 640,ysize = 480,i,j,frameNumber;
int pausemode = 0, paused = 0;
long  lbuf[481][640];
char  fbuf[481][640];
char  hbuf[481][640];
long curfpos;
long win;
int c;
int BackUp=0;
int CopyFile=0;
int WhereAmI = 0;
int GetHistogram = 0;
int JumpAhead = 0;
int HistogramArray[256];

typedef struct flink {
 	long fpos;
        int FrameNum;
	int  complete;
	struct flink *next;
	struct flink *prev;
        } flink;

flink *start,*current;
void usage(void);
void CheckForPause();
void GetTimeStamp(void);
void ReadAndDrawFrame(void);
void GetMyDate(char *mydate);
void CopyRestOfFile(void);
void DirectionText(char *s);
void PausedText(char *s);
void Restart(void);
void initialize();

char s[100];
char infilename[100];
char mydate[100];
int FirstTimeThrough = 1;
int token;

getdata() {

    if(strlen(infilename) == 0)
       strcpy(infilename,"security.out");

    fp = fopen(infilename,"r");
    if(fp == NULL)
     {
      fprintf(stderr,"Could not open file '%s'\n",infilename);
      exit(1);
     }
 
    if(JumpAhead)
     {
       fseek(fp,curfpos,SEEK_SET);
     }
     
     while(1)
      {
        if(BackUp)
         {
          if(current->prev->prev)
           {
             fseek(fp,current->prev->fpos,SEEK_SET);
             current = current->prev->prev;
             frameNumber = current->FrameNum;
             memset(lbuf,0,4*xsize*ysize);
           }
          else
           {
             current = start;
             fseek(fp,0,SEEK_SET);
             frameNumber = current->FrameNum;
             BackUp = 0;
             pausemode = 1;
             paused = 1;
             DirectionText("FORWARD");
             PausedText("PAUSED");
           }
         }
        else
         {
         }
          
        if(WhereAmI)
         {
           curfpos = ftell(fp);
           fprintf(stderr,"Current File pointer is %ld\n",curfpos);
           WhereAmI = 0;
         }

        fread(&token,sizeof(int),1,fp);
        if(feof(fp))
         {
           DirectionText("REVERSE");
           BackUp = 1;
           pausemode = 1;
           PausedText("PAUSED (END OF FILE)");
           continue;
         }

        switch(token){

        case SECURITYFILETIMESTAMP:
          if(CopyFile)
             CopyRestOfFile();
          GetTimeStamp();
          fread(&token,sizeof(int),1,fp);
          if(token != SECURITYFILERECTANGLE)
            {
             fprintf(stderr,"Did not find SECURITYFILERECTANGLE token\n");
             exit(1);
            }
          CheckForPause();
          ReadAndDrawFrame();
          
          break;
        default:
           fprintf(stderr,"Unknown token %d found\n",token);
           while( !feof(fp))
            {
             token = 0;
             while((!feof(fp)) && (token != SECURITYFILETIMESTAMP))
               fread(&token,sizeof(int),1,fp);
             
             fread(&now,sizeof(time_t),1,fp);
             fread(&token,sizeof(int),1,fp);
             if(token != SECURITYFILERECTANGLE)
               continue;
             fread(&minx,sizeof(int),1,fp);
             fread(&miny,sizeof(int),1,fp);
             fread(&maxx,sizeof(int),1,fp);
             fread(&maxy,sizeof(int),1,fp);
             if((minx < 0) || (minx > 640)) continue;
             if((miny < 0) || (miny > 640)) continue;
             if((maxx < 0) || (maxx > 640)) continue;
             if((maxy < 0) || (maxy > 640)) continue;
               break;
            }
           if(feof(fp))
            {
              fprintf(stderr,"Unable to synchronize\n");
              exit(1);
            }
           else
            {
             curfpos = ftell(fp);
             curfpos -= sizeof(int);
             curfpos -= sizeof(time_t);
             curfpos -= sizeof(int);
             curfpos -= sizeof(int);
             curfpos -= sizeof(int);
             curfpos -= sizeof(int);
             curfpos -= sizeof(int);
             fseek(fp,curfpos,SEEK_SET);
             fprintf(stderr,"Resynched\n");
            }
           break;
        }  
     } 
}


void initialize() 
   {
    foreground();
    prefsize(xsize,500);
    win = winopen("Security File Viewer");
    RGBmode();
    pixmode(PM_TTOB, 1);
    singlebuffer();
    gconfig();
    mapcolor (0, 0, 0, 0);
    mapcolor (1, 255, 0, 0);
    ortho2(0,640,0,500);

    qdevice(ESCKEY);
    qdevice(HOMEKEY);
    qdevice(CKEY);
    qdevice(HKEY);
    qdevice(WKEY);
    qdevice(MIDDLEMOUSE);
    qdevice(RIGHTMOUSE);
    qdevice(LEFTMOUSE);
    qdevice(MOUSEX);
    qdevice(MOUSEY);
    sleep(1);        /* allow time to click for pause mode if wanted */
}



int main(int argc, char **argv) 
 {
    long dev;
    short val;

    current = (flink *)calloc(1,sizeof(flink));
    start = current ;
    if(current == NULL)
     { 
       fprintf(stderr,"Could not allocate memory for link\n");
       exit(1);
     }

    if(argc < 2)
     {
      usage();
      exit(1);
     }

    if(strcmp(argv[1],"-f") == 0)
      strcpy(infilename,argv[2]);
    else
      strcpy(infilename,argv[1]);

    if(argc > 2)
     {
      curfpos = atoi(argv[2]);
       fprintf(stderr,"File pointer will be positioned at %ld '%s'\n",curfpos,argv[2]);
      JumpAhead = 1;
     }

    printf("Press left mouse to view frame by frame.\n");
    printf("Press middle mouse to return to continuous play\n");
    printf("Press right mouse to reverse direction of play\n");

    initialize();            /* set up graphics and initialize variables */
    getdata();

}               /* End of main (infinite) loop */


void usage(void)
{
fprintf(stderr,"USAGE: securityviewer filename\n");
}



void GetMyDate(char *mydate)
{
char *cp;
cp = ctime(&now);
mydate[0] = '\0';
cp += 4;
strncat(mydate,cp,3);
cp += 4;
strcat(mydate," ");
strncat(mydate,cp,2);
strcat(mydate," ");
cp += 3;
strncat(mydate,cp,2);
strcat(mydate,":");
cp += 3;
strncat(mydate,cp,2);
strcat(mydate,":");
cp += 3;
strncat(mydate,cp,2);
}


void CheckForPause()
{
   long dev;
   short val;

   while(TRUE)
    {
     while (qtest()) {
       switch(dev=qread(&val)) {

                case CKEY:
                    if (val)                        /* exit on up, not down */
                        break;
                    CopyFile = 1;
                    break;
                case WKEY:
                    if (val)                        /* exit on up, not down */
                        break;
                    WhereAmI = 1;
                    break;
                case HKEY:
                    if (val)                        /* exit on up, not down */
                        break;
                    GetHistogram = 1;
                    break;
                case HOMEKEY:
                    if (val)                        /* exit on up, not down */
                        break;
                    Restart();
                    break;
                case ESCKEY:
                    if (val)                        /* exit on up, not down */
                        break;
                    exit(0);
                case LEFTMOUSE:
                    if (val)                        /* exit on up, not down */
                        break;
                    if(pausemode == 0)
                      {
                       pausemode = 1;
                       paused = 1;
                       PausedText("PAUSED");
                      }
                    else
                      {
                      paused = 0;
                      }
                    break;
                case MIDDLEMOUSE:
                    if (val)                        /* exit on up, not down */
                        break;
                    pausemode = 0;
                    PausedText("");
                    break;
                case RIGHTMOUSE:
                    if (val)                        /* exit on up, not down */
                        break;
                    if(BackUp)
                     {
                      BackUp = 0;
                      DirectionText("FORWARD");
                      pausemode = 1;
                      PausedText("PAUSED");
                      paused = 1;
                     }
                    else
                     {
                      BackUp = 1;
                      memset(lbuf,0,4*xsize*ysize);
                      pausemode = 1;
                      paused = 1;
                      PausedText("PAUSED");
                      DirectionText("REVERSE");
                     }
                    break;
                default:
                    break;
               }
      }
    if(pausemode == 0) break;
    if(paused == 0) break;
   }
}

void GetTimeStamp(void)
{

          if(current == NULL)
            { fprintf(stderr,"Current is null\n");
              exit(1);
            }
          if(current->next == NULL)
           {
            current->next = (flink*) calloc(1,sizeof(flink));
            current->next->FrameNum = current->FrameNum+1;
           }
          current->next->prev = current;
          current = current->next;
          current->fpos = ftell(fp);
          current->fpos-=4;
          frameNumber = current->FrameNum;
          fread(&now,sizeof(time_t),1,fp);
          GetMyDate(mydate);
}



void ReadAndDrawFrame(void)
{
          fread(&minx,sizeof(int),1,fp);
          fread(&miny,sizeof(int),1,fp);
          fread(&maxx,sizeof(int),1,fp);
          fread(&maxy,sizeof(int),1,fp);
          for(y=miny;y<=maxy;y++)
            {
                fread(&fbuf[y][minx],sizeof(char),maxx-minx+1,fp);
                for(x=minx;x<=maxx;x++)
                  lbuf[y][x] = fbuf[y][x] + (fbuf[y][x] << 8) + (fbuf[y][x] << 16);
            }
          lrectwrite(0,20, xsize-1, ysize-1+20,(unsigned long*)(&lbuf[0][0]));
          RGBcolor(0,0,0);
          rectfi(0,0,640,19);
          RGBcolor(255,255,255);
          cmov2i(1,5);
          sprintf(s,"Frame %d ",frameNumber);
          charstr(s);
          if(BackUp)
            DirectionText("REVERSE");
          else
            DirectionText("FORWARD");

          if(pausemode)
            PausedText("PAUSED");
        
          cmov2i(500,5);
          charstr(mydate);
          
          paused = 1;
          if(GetHistogram == 1)
           {
             for(y=miny;y<=maxy;y++)
                for(x=minx;x<=maxx;x++)
                  hbuf[y][x] = fbuf[y][x];
           }

          if(GetHistogram == 2)
           {
             for(y=0;y<255;y++)
               HistogramArray[y] = 0;

             for(y=miny;y<=maxy;y++)
                for(x=minx;x<=maxx;x++)
                  HistogramArray[abs(hbuf[y][x]-fbuf[y][x])] += 1;

             for(y=0;y<255;y++)
               if(HistogramArray[y])
                 fprintf(stderr," %3d %5d\n",y,HistogramArray[y]);
             
             GetHistogram = 0;
           }
          if(GetHistogram == 1)
            GetHistogram = 2;
}


void CopyRestOfFile(void)
{
int buf;
long start;
FILE *nfp;

fprintf(stderr,"Copying remainder of file to 'SecurityFileCopy'\n");
nfp = fopen("SecurityFileCopy","w");
if(nfp == NULL)
  {
   fprintf(stderr,"Could not open file 'SecurityFileCopy'\n");
   return;
  }
start = ftell(fp);
fseek(fp,start-4,SEEK_SET);
while(!feof(fp))
 {
   fread(&buf,sizeof(int),1,fp);
   fwrite(&buf,sizeof(int),1,nfp);
 }
fclose(nfp);
fseek(fp,start,SEEK_SET);
fprintf(stderr,"Copy complete\n");
CopyFile = 0;
}


void DirectionText(char *s)
{
  frontbuffer(TRUE);
  RGBcolor(0,0,0);
  rectfi(200,0,280,19);
  RGBcolor(255,255,255);
  cmov2i(200,5);
  charstr(s);
  frontbuffer(FALSE);
}


void PausedText(char *s)
{
  frontbuffer(TRUE);
  RGBcolor(0,0,0);
  rectfi(300,0,480,19);
  RGBcolor(255,255,255);
  cmov2i(300,5);
  charstr(s);
  frontbuffer(FALSE);
}

void Restart(void)
{

  current = start;
  BackUp = 0;
  memset(lbuf,0,4*xsize*ysize);   /* Clear display buffer */
  fseek(fp,0,SEEK_SET);           /* go to file start      */
  fread(&token,sizeof(int),1,fp); /* read time token       */
  GetTimeStamp();                 /* get the time stamp    */
  fread(&token,sizeof(int),1,fp); /* read rectangle token  */
  ReadAndDrawFrame();             
  fread(&token,sizeof(int),1,fp); 
  GetTimeStamp();                 /* get the time stamp    */
  fread(&token,sizeof(int),1,fp);
  pausemode = 1;
  paused = 1;
  PausedText("PAUSED");
}
